Index: LMDZ5/branches/testing/libf/phylmd/cloudth.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cloudth.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/cloudth.F90	(revision 2298)
@@ -5,4 +5,5 @@
 
 
+      USE IOIPSL, ONLY : getin
       IMPLICIT NONE
 
@@ -39,5 +40,5 @@
       
       
-      REAL sigma1(ngrid,klev)                                                         
+      REAL sigma1(ngrid,klev)
       REAL sigma2(ngrid,klev)
       REAL qlth(ngrid,klev)
@@ -48,5 +49,5 @@
       REAL ctot(ngrid,klev)
       REAL rneb(ngrid,klev)
-      REAL t(ngrid,klev)                                                                  
+      REAL t(ngrid,klev)
       REAL qsatmmussig1,qsatmmussig2,sqrt2pi,pi
       REAL rdd,cppd,Lv
@@ -62,18 +63,39 @@
       REAL erf
 
-
-
-
-
-!      print*,ngrid,klev,ind1,ind2,ztv(ind1,ind2),po(ind1),zqta(ind1,ind2), &
-!     &       fraca(ind1,ind2),zpspsk(ind1,ind2),paprs(ind1,ind2),ztla(ind1,ind2),zthl(ind1,ind2), &
-!     &       'verif'
-
-
-!      LOGICAL active(ngrid)   
-      
-!-----------------------------------------------------------------------------------------------------------------
+      REAL, SAVE :: iflag_cloudth_vert, iflag_cloudth_vert_omp=0
+
+
+      LOGICAL, SAVE :: first=.true.
+
+
+
+
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+! Astuce pour gérer deux versions de cloudth en attendant
+! de converger sur une version nouvelle
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+      IF (first) THEN
+     !$OMP MASTER
+     CALL getin('iflag_cloudth_vert',iflag_cloudth_vert_omp)
+     !$OMP END MASTER
+     !$OMP BARRIER
+     iflag_cloudth_vert=iflag_cloudth_vert_omp
+      first=.false.
+      ENDIF
+       IF (iflag_cloudth_vert==1) THEN
+       CALL cloudth_vert(ngrid,klev,ind2,  &
+     &           ztv,po,zqta,fraca, & 
+     &           qcloud,ctot,zpspsk,paprs,ztla,zthl, &
+     &           ratqs,zqs,t)
+       RETURN
+       ENDIF
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+
+
+!-------------------------------------------------------------------------------
 ! Initialisation des variables r?elles
-!-----------------------------------------------------------------------------------------------------------------
+!-------------------------------------------------------------------------------
       sigma1(:,:)=0.
       sigma2(:,:)=0.
@@ -96,7 +118,7 @@
 
 
-!------------------------------------------------------------------------------------------------------------------
+!-------------------------------------------------------------------------------
 ! Calcul de la fraction du thermique et des ?cart-types des distributions
-!------------------------------------------------------------------------------------------------------------------                 
+!-------------------------------------------------------------------------------                 
       do ind1=1,ngrid
 
@@ -139,7 +161,7 @@
       
 
-!-----------------------------------------------------------------------------------------------------------------
+!------------------------------------------------------------------------------
 ! Calcul des ?cart-types pour s
-!-----------------------------------------------------------------------------------------------------------------
+!------------------------------------------------------------------------------
 
 !      sigma1s=(1.1**0.5)*(fraca(ind1,ind2)**0.6)/(1-fraca(ind1,ind2))*((sth-senv)**2)**0.5+ratqs(ind1,ind2)*po(ind1)
@@ -155,7 +177,7 @@
 !      sigma2s=0.11*((sth-senv)**2)**0.5/(fraca(ind1,ind2)+0.02)**0.4+0.00003  
  
-!-----------------------------------------------------------------------------------------------------------------
+!------------------------------------------------------------------------------
 ! Calcul de l'eau condens?e et de la couverture nuageuse
-!-----------------------------------------------------------------------------------------------------------------
+!------------------------------------------------------------------------------
       sqrt2pi=sqrt(2.*pi)
       xth=sth/(sqrt(2.)*sigma2s)
@@ -176,5 +198,5 @@
 !      print*,senv,sth,sigma1s,sigma2s,fraca(ind1,ind2),'senv et sth et sig1 et sig2 et alpha'
 
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
       if (ctot(ind1,ind2).lt.1.e-10) then
       ctot(ind1,ind2)=0.
@@ -242,9 +264,285 @@
 
 
-
-
-                                                                            
-
-
-
-
+!===========================================================================
+     SUBROUTINE cloudth_vert(ngrid,klev,ind2,  &
+     &           ztv,po,zqta,fraca, & 
+     &           qcloud,ctot,zpspsk,paprs,ztla,zthl, &
+     &           ratqs,zqs,t)
+
+
+      IMPLICIT NONE
+
+
+!===========================================================================
+! Auteur : Arnaud Octavio Jam (LMD/CNRS)
+! Date : 25 Mai 2010
+! Objet : calcule les valeurs de qc et rneb dans les thermiques
+!===========================================================================
+
+
+#include "YOMCST.h"
+#include "YOETHF.h"
+#include "FCTTRE.h"
+#include "iniprint.h"
+#include "thermcell.h"
+
+      INTEGER itap,ind1,ind2
+      INTEGER ngrid,klev,klon,l,ig 
+      
+      REAL ztv(ngrid,klev)
+      REAL po(ngrid)
+      REAL zqenv(ngrid)   
+      REAL zqta(ngrid,klev)
+          
+      REAL fraca(ngrid,klev+1)
+      REAL zpspsk(ngrid,klev)
+      REAL paprs(ngrid,klev+1)
+      REAL ztla(ngrid,klev)
+      REAL zthl(ngrid,klev)
+
+      REAL zqsatth(ngrid,klev)
+      REAL zqsatenv(ngrid,klev)
+      
+      
+      REAL sigma1(ngrid,klev)                                                         
+      REAL sigma2(ngrid,klev)
+      REAL qlth(ngrid,klev)
+      REAL qlenv(ngrid,klev)
+      REAL qltot(ngrid,klev) 
+      REAL cth(ngrid,klev)  
+      REAL cenv(ngrid,klev)   
+      REAL ctot(ngrid,klev)
+      REAL rneb(ngrid,klev)
+      REAL t(ngrid,klev)                                                                  
+      REAL qsatmmussig1,qsatmmussig2,sqrt2pi,pi
+      REAL rdd,cppd,Lv,sqrt2,sqrtpi
+      REAL alth,alenv,ath,aenv
+      REAL sth,senv,sigma1s,sigma2s,xth,xenv
+      REAL xth1,xth2,xenv1,xenv2,deltasth, deltasenv
+      REAL IntJ,IntI1,IntI2,IntI3,coeffqlenv,coeffqlth
+      REAL Tbef,zdelta,qsatbef,zcor
+      REAL alpha,qlbef  
+      REAL ratqs(ngrid,klev) ! determine la largeur de distribution de vapeur
+      
+      REAL zpdf_sig(ngrid),zpdf_k(ngrid),zpdf_delta(ngrid)
+      REAL zpdf_a(ngrid),zpdf_b(ngrid),zpdf_e1(ngrid),zpdf_e2(ngrid) 
+      REAL zqs(ngrid), qcloud(ngrid)
+      REAL erf
+
+
+
+
+
+!------------------------------------------------------------------------------
+! Initialisation des variables r?elles
+!------------------------------------------------------------------------------
+      sigma1(:,:)=0.
+      sigma2(:,:)=0.
+      qlth(:,:)=0.
+      qlenv(:,:)=0.  
+      qltot(:,:)=0.
+      rneb(:,:)=0.
+      qcloud(:)=0.
+      cth(:,:)=0.
+      cenv(:,:)=0.
+      ctot(:,:)=0.
+      qsatmmussig1=0.
+      qsatmmussig2=0.
+      rdd=287.04
+      cppd=1005.7
+      pi=3.14159 
+      Lv=2.5e6
+      sqrt2pi=sqrt(2.*pi)
+      sqrt2=sqrt(2.)
+      sqrtpi=sqrt(pi)
+
+
+
+!-------------------------------------------------------------------------------
+! Calcul de la fraction du thermique et des ?cart-types des distributions
+!-------------------------------------------------------------------------------                 
+      do ind1=1,ngrid
+
+      if ((ztv(ind1,1).gt.ztv(ind1,2)).and.(fraca(ind1,ind2).gt.1.e-10)) then 
+
+      zqenv(ind1)=(po(ind1)-fraca(ind1,ind2)*zqta(ind1,ind2))/(1.-fraca(ind1,ind2))
+
+
+!      zqenv(ind1)=po(ind1)
+      Tbef=zthl(ind1,ind2)*zpspsk(ind1,ind2)
+      zdelta=MAX(0.,SIGN(1.,RTT-Tbef))
+      qsatbef= R2ES * FOEEW(Tbef,zdelta)/paprs(ind1,ind2)
+      qsatbef=MIN(0.5,qsatbef)
+      zcor=1./(1.-retv*qsatbef)
+      qsatbef=qsatbef*zcor
+      zqsatenv(ind1,ind2)=qsatbef
+
+
+
+
+      alenv=(0.622*Lv*zqsatenv(ind1,ind2))/(rdd*zthl(ind1,ind2)**2)  
+      aenv=1./(1.+(alenv*Lv/cppd))
+      senv=aenv*(po(ind1)-zqsatenv(ind1,ind2)) 
+
+
+
+
+      Tbef=ztla(ind1,ind2)*zpspsk(ind1,ind2)
+      zdelta=MAX(0.,SIGN(1.,RTT-Tbef))
+      qsatbef= R2ES * FOEEW(Tbef,zdelta)/paprs(ind1,ind2)
+      qsatbef=MIN(0.5,qsatbef)
+      zcor=1./(1.-retv*qsatbef)
+      qsatbef=qsatbef*zcor
+      zqsatth(ind1,ind2)=qsatbef
+            
+      alth=(0.622*Lv*zqsatth(ind1,ind2))/(rdd*ztla(ind1,ind2)**2)   
+      ath=1./(1.+(alth*Lv/cppd))
+      sth=ath*(zqta(ind1,ind2)-zqsatth(ind1,ind2)) 
+      
+      
+
+!------------------------------------------------------------------------------
+! Calcul des ?cart-types pour s
+!------------------------------------------------------------------------------
+
+      sigma1s=(0.92**0.5)*(fraca(ind1,ind2)**0.5)/(1-fraca(ind1,ind2))*((sth-senv)**2)**0.5+ratqs(ind1,ind2)*po(ind1)
+      sigma2s=0.09*((sth-senv)**2)**0.5/(fraca(ind1,ind2)+0.02)**0.5+0.002*zqta(ind1,ind2) 
+!       if (paprs(ind1,ind2).gt.90000) then
+!       ratqs(ind1,ind2)=0.002
+!       else 
+!       ratqs(ind1,ind2)=0.002+0.0*(90000-paprs(ind1,ind2))/20000
+!       endif
+!       sigma1s=(1.1**0.5)*(fraca(ind1,ind2)**0.6)/(1-fraca(ind1,ind2))*((sth-senv)**2)**0.5+0.002*po(ind1)
+!       sigma2s=0.11*((sth-senv)**2)**0.5/(fraca(ind1,ind2)+0.01)**0.4+0.002*zqta(ind1,ind2) 
+!       sigma1s=ratqs(ind1,ind2)*po(ind1)
+!      sigma2s=0.11*((sth-senv)**2)**0.5/(fraca(ind1,ind2)+0.02)**0.4+0.00003  
+ 
+!------------------------------------------------------------------------------
+! Calcul de l'eau condens?e et de la couverture nuageuse
+!------------------------------------------------------------------------------
+      sqrt2pi=sqrt(2.*pi)
+      xth=sth/(sqrt(2.)*sigma2s)
+      xenv=senv/(sqrt(2.)*sigma1s)
+      cth(ind1,ind2)=0.5*(1.+1.*erf(xth))
+      cenv(ind1,ind2)=0.5*(1.+1.*erf(xenv)) 
+      ctot(ind1,ind2)=fraca(ind1,ind2)*cth(ind1,ind2)+(1.-1.*fraca(ind1,ind2))*cenv(ind1,ind2)   
+!      ctot(ind1,ind2)=alpha*cth(ind1,ind2)+(1.-1.*alpha)*cenv(ind1,ind2) 
+
+
+
+      qlth(ind1,ind2)=sigma2s*((exp(-1.*xth**2)/sqrt2pi)+xth*sqrt(2.)*cth(ind1,ind2))
+      qlenv(ind1,ind2)=sigma1s*((exp(-1.*xenv**2)/sqrt2pi)+xenv*sqrt(2.)*cenv(ind1,ind2))   
+      qltot(ind1,ind2)=fraca(ind1,ind2)*qlth(ind1,ind2)+(1.-1.*fraca(ind1,ind2))*qlenv(ind1,ind2)
+!      qltot(ind1,ind2)=alpha*qlth(ind1,ind2)+(1.-1.*alpha)*qlenv(ind1,ind2)
+     
+
+!      print*,senv,sth,sigma1s,sigma2s,fraca(ind1,ind2),'senv et sth et sig1 et sig2 et alpha'
+
+
+!-------------------------------------------------------------------------------
+!  Version 2: Modification selon J.-Louis. On condense ?? partir de qsat-ratqs
+!-------------------------------------------------------------------------------
+!      deltasenv=aenv*ratqs(ind1,ind2)*po(ind1)
+!      deltasth=ath*ratqs(ind1,ind2)*zqta(ind1,ind2)
+      deltasenv=aenv*ratqs(ind1,ind2)*zqsatenv(ind1,ind2)
+      deltasth=ath*ratqs(ind1,ind2)*zqsatth(ind1,ind2)
+!      deltasenv=aenv*0.01*po(ind1)
+!     deltasth=ath*0.01*zqta(ind1,ind2)    
+      xenv1=(senv-deltasenv)/(sqrt(2.)*sigma1s)
+      xenv2=(senv+deltasenv)/(sqrt(2.)*sigma1s)
+      xth1=(sth-deltasth)/(sqrt(2.)*sigma2s)
+      xth2=(sth+deltasth)/(sqrt(2.)*sigma2s)
+      coeffqlenv=(sigma1s)**2/(2*sqrtpi*deltasenv)
+      coeffqlth=(sigma2s)**2/(2*sqrtpi*deltasth)
+      
+      cth(ind1,ind2)=0.5*(1.+1.*erf(xth2))
+      cenv(ind1,ind2)=0.5*(1.+1.*erf(xenv2)) 
+      ctot(ind1,ind2)=fraca(ind1,ind2)*cth(ind1,ind2)+(1.-1.*fraca(ind1,ind2))*cenv(ind1,ind2)   
+
+      IntJ=sigma1s*(exp(-1.*xenv1**2)/sqrt2pi)+0.5*senv*(1+erf(xenv1))
+      IntI1=coeffqlenv*0.5*(0.5*sqrtpi*(erf(xenv2)-erf(xenv1))+xenv1*exp(-1.*xenv1**2)-xenv2*exp(-1.*xenv2**2))
+      IntI2=coeffqlenv*xenv2*(exp(-1.*xenv2**2)-exp(-1.*xenv1**2))
+      IntI3=coeffqlenv*0.5*sqrtpi*xenv2**2*(erf(xenv2)-erf(xenv1))
+
+      qlenv(ind1,ind2)=IntJ+IntI1+IntI2+IntI3
+!      qlenv(ind1,ind2)=IntJ 
+!      print*, qlenv(ind1,ind2),'VERIF EAU'
+
+
+      IntJ=sigma2s*(exp(-1.*xth1**2)/sqrt2pi)+0.5*sth*(1+erf(xth1))
+!      IntI1=coeffqlth*((0.5*xth1-xth2)*exp(-1.*xth1**2)+0.5*xth2*exp(-1.*xth2**2))
+!      IntI2=coeffqlth*0.5*sqrtpi*(0.5+xth2**2)*(erf(xth2)-erf(xth1))
+      IntI1=coeffqlth*0.5*(0.5*sqrtpi*(erf(xth2)-erf(xth1))+xth1*exp(-1.*xth1**2)-xth2*exp(-1.*xth2**2))
+      IntI2=coeffqlth*xth2*(exp(-1.*xth2**2)-exp(-1.*xth1**2))
+      IntI3=coeffqlth*0.5*sqrtpi*xth2**2*(erf(xth2)-erf(xth1))
+      qlth(ind1,ind2)=IntJ+IntI1+IntI2+IntI3
+!      qlth(ind1,ind2)=IntJ
+!      print*, IntJ,IntI1,IntI2,IntI3,qlth(ind1,ind2),'VERIF EAU2'
+      qltot(ind1,ind2)=fraca(ind1,ind2)*qlth(ind1,ind2)+(1.-1.*fraca(ind1,ind2))*qlenv(ind1,ind2)
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+      if (cenv(ind1,ind2).lt.1.e-10.or.cth(ind1,ind2).lt.1.e-10) then
+      ctot(ind1,ind2)=0.
+      qcloud(ind1)=zqsatenv(ind1,ind2) 
+
+      else 
+                
+      ctot(ind1,ind2)=ctot(ind1,ind2) 
+      qcloud(ind1)=qltot(ind1,ind2)/ctot(ind1,ind2)+zqs(ind1)
+!      qcloud(ind1)=fraca(ind1,ind2)*qlth(ind1,ind2)/cth(ind1,ind2) &
+!    &             +(1.-1.*fraca(ind1,ind2))*qlenv(ind1,ind2)/cenv(ind1,ind2)+zqs(ind1) 
+
+      endif  
+                       
+      
+          
+!     print*,sth,sigma2s,qlth(ind1,ind2),ctot(ind1,ind2),qltot(ind1,ind2),'verif'
+
+
+      else  ! gaussienne environnement seule
+      
+      zqenv(ind1)=po(ind1)
+      Tbef=t(ind1,ind2)
+      zdelta=MAX(0.,SIGN(1.,RTT-Tbef))
+      qsatbef= R2ES * FOEEW(Tbef,zdelta)/paprs(ind1,ind2)
+      qsatbef=MIN(0.5,qsatbef)
+      zcor=1./(1.-retv*qsatbef)
+      qsatbef=qsatbef*zcor
+      zqsatenv(ind1,ind2)=qsatbef
+      
+
+!      qlbef=Max(po(ind1)-zqsatenv(ind1,ind2),0.)
+      zthl(ind1,ind2)=t(ind1,ind2)*(101325/paprs(ind1,ind2))**(rdd/cppd)
+      alenv=(0.622*Lv*zqsatenv(ind1,ind2))/(rdd*zthl(ind1,ind2)**2)  
+      aenv=1./(1.+(alenv*Lv/cppd))
+      senv=aenv*(po(ind1)-zqsatenv(ind1,ind2)) 
+      
+
+      sigma1s=ratqs(ind1,ind2)*zqenv(ind1)
+
+      sqrt2pi=sqrt(2.*pi)
+      xenv=senv/(sqrt(2.)*sigma1s)
+      ctot(ind1,ind2)=0.5*(1.+1.*erf(xenv))
+      qltot(ind1,ind2)=sigma1s*((exp(-1.*xenv**2)/sqrt2pi)+xenv*sqrt(2.)*cenv(ind1,ind2))
+      
+      if (ctot(ind1,ind2).lt.1.e-3) then
+      ctot(ind1,ind2)=0.
+      qcloud(ind1)=zqsatenv(ind1,ind2) 
+
+      else   
+                
+      ctot(ind1,ind2)=ctot(ind1,ind2) 
+      qcloud(ind1)=qltot(ind1,ind2)/ctot(ind1,ind2)+zqsatenv(ind1,ind2)
+
+      endif    
+ 
+ 
+ 
+ 
+ 
+ 
+      endif   
+      enddo
+     
+      return
+      end
Index: LMDZ5/branches/testing/libf/phylmd/coef_diff_turb_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/coef_diff_turb_mod.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/coef_diff_turb_mod.F90	(revision 2298)
@@ -13,5 +13,5 @@
 !
   SUBROUTINE coef_diff_turb(dtime, nsrf, knon, ni, &
-       ypaprs, ypplay, yu, yv, yq, yt, yts, yrugos, yqsurf, ycdragm, &
+       ypaprs, ypplay, yu, yv, yq, yt, yts, yqsurf, ycdragm, &
        ycoefm, ycoefh ,yq2)
  
@@ -34,5 +34,5 @@
     REAL, DIMENSION(klon,klev), INTENT(IN)     :: yu, yv
     REAL, DIMENSION(klon,klev), INTENT(IN)     :: yq, yt
-    REAL, DIMENSION(klon), INTENT(IN)          :: yts, yrugos, yqsurf
+    REAL, DIMENSION(klon), INTENT(IN)          :: yts, yqsurf
     REAL, DIMENSION(klon), INTENT(IN)          :: ycdragm
 
@@ -70,5 +70,5 @@
     CALL coefkz(nsrf, knon, ypaprs, ypplay, &
          ksta, ksta_ter, &
-         yts, yrugos, yu, yv, yt, yq, &
+         yts, yu, yv, yt, yq, &
          yqsurf, &
          ycoefm, ycoefh)
@@ -181,5 +181,5 @@
   SUBROUTINE coefkz(nsrf, knon, paprs, pplay, &
        ksta, ksta_ter, &
-       ts, rugos, &
+       ts, &
        u,v,t,q, &
        qsurf, &
@@ -200,5 +200,4 @@
 ! pplay----input-R- pression au milieu de chaque couche (en Pa)
 ! ts-------input-R- temperature du sol (en Kelvin)
-! rugos----input-R- longeur de rugosite (en m)
 ! u--------input-R- vitesse u
 ! v--------input-R- vitesse v
@@ -223,5 +222,4 @@
     REAL, DIMENSION(klon,klev), INTENT(IN)   :: pplay
     REAL, DIMENSION(klon,klev), INTENT(IN)   :: u, v, t, q
-    REAL, DIMENSION(klon), INTENT(IN)        :: rugos
     REAL, DIMENSION(klon), INTENT(IN)        :: qsurf
 
Index: LMDZ5/branches/testing/libf/phylmd/compar1d.h
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/compar1d.h	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/compar1d.h	(revision 2298)
@@ -9,5 +9,5 @@
       real :: tsurf
       real :: rugos
-      real :: qsol(1:2)
+      real :: xqsol(1:2)
       real :: qsurf
       real :: psurf
@@ -32,5 +32,5 @@
       common/com_par1d/                                                 &
      & nat_surf,tsurf,rugos,                                            &
-     & qsol,qsurf,psurf,zsurf,albedo,time,time_ini,xlat,xlon,airefi,    &
+     & xqsol,qsurf,psurf,zsurf,albedo,time,time_ini,xlat,xlon,airefi,   &
      & wtsurf,wqsurf,restart_runoff,xagesno,qsolinp,zpicinp,            &
      & forcing_type,tend_u,tend_v,tend_w,tend_t,tend_q,tend_rayo,       &
Index: LMDZ5/branches/testing/libf/phylmd/concvl.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/concvl.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/concvl.F90	(revision 2298)
@@ -1,4 +1,4 @@
 SUBROUTINE concvl(iflag_clos, &
-                  dtime, paprs, pplay, &
+                  dtime, paprs, pplay, k_upper_cv, &
                   t, q, t_wake, q_wake, s_wake, u, v, tra, ntra, &
                   Ale, Alp, sig1, w01, &
@@ -88,4 +88,5 @@
 
   REAL dtime, paprs(klon, klev+1), pplay(klon, klev)
+  INTEGER k_upper_cv
   REAL t(klon, klev), q(klon, klev), u(klon, klev), v(klon, klev)
   REAL t_wake(klon, klev), q_wake(klon, klev)
@@ -214,4 +215,7 @@
   include "FCTTRE.h"
   include "iniprint.h"
+!jyg<
+  include "conema3.h"
+!>jyg
 
   IF (first) THEN
@@ -307,5 +311,8 @@
 
   em_sig1feed = 1.
-  em_sig2feed = 0.97
+!jyg<
+!  em_sig2feed = 0.97
+  em_sig2feed = cvl_sig2feed
+!>jyg
 ! em_sig2feed = 0.8
 ! Relative Weight densities
@@ -399,7 +406,7 @@
 !LF   necessary for gathered fields
     nloc = klon
-    CALL cva_driver(klon, klev, klev+1, ntra, nloc, &
+    CALL cva_driver(klon, klev, klev+1, ntra, nloc, k_upper_cv, &
                     iflag_con, iflag_mix, iflag_ice_thermo, &
-                    iflag_clos, ok_conserv_q, dtime, &
+                    iflag_clos, ok_conserv_q, dtime, cvl_comp_threshold, &
                     t, q, qs, t_wake, q_wake, qs_wake, s_wake, u, v, tra, &
                     em_p, em_ph, &
Index: LMDZ5/branches/testing/libf/phylmd/conema3.h
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/conema3.h	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/conema3.h	(revision 2298)
@@ -4,14 +4,21 @@
 !
       real epmax             ! 0.993
+!jyg<
+      REAL  cvl_comp_threshold     ! 0.
+!>jyg
       logical ok_adj_ema      ! F
       integer iflag_clw      ! 0
       integer iflag_cvl_sigd
-      real sig1feed      ! 1.
-      real sig2feed      ! 0.95
+      real cvl_sig2feed      ! 0.97
 
-      common/comconema1/epmax,ok_adj_ema,iflag_clw,sig1feed,sig2feed
-      common/comconema2/iflag_cvl_sigd
+!jyg<
+!!      common/comconema1/epmax,ok_adj_ema,iflag_clw,sig1feed,sig2feed
+!!      common/comconema2/iflag_cvl_sigd
+      common/comconema1/epmax, cvl_comp_threshold, cvl_sig2feed
+      common/comconema2/iflag_cvl_sigd, iflag_clw, ok_adj_ema
+!>jyg
 
 !      common/comconema/epmax,ok_adj_ema,iflag_clw
 !$OMP THREADPRIVATE(/comconema1/)
 !$OMP THREADPRIVATE(/comconema2/)
+
Index: LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90	(revision 2298)
@@ -40,4 +40,5 @@
     include "thermcell.h"
     include "iniprint.h"
+
 
     !IM : on inclut/initialise les taux de CH4, N2O, CFC11 et CFC12
@@ -117,5 +118,8 @@
 
     Real,SAVE           :: f_cdrag_ter_omp,f_cdrag_oce_omp
-    Real,SAVE           :: f_rugoro_omp   
+    Real,SAVE           :: f_rugoro_omp   , z0min_omp
+    Real,SAVE           :: z0m_seaice_omp,z0h_seaice_omp
+    REAL,SAVE           :: min_wind_speed_omp,f_gust_wk_omp,f_gust_bl_omp,f_qsat_oce_omp, f_z0qh_oce_omp
+    INTEGER,SAVE        :: iflag_gusts_omp,iflag_z0_oce_omp
 
     ! Local
@@ -142,4 +146,5 @@
     INTEGER, SAVE :: iflag_mix_omp
     real, save :: scut_omp, qqa1_omp, qqa2_omp, gammas_omp, Fmax_omp, alphas_omp
+    REAL, SAVE :: tmax_fonte_cv_omp
 
     REAL,SAVE :: R_ecc_omp,R_peri_omp,R_incl_omp,solaire_omp
@@ -188,4 +193,6 @@
     REAL,SAVE :: ecrit_LES_omp
     REAL,SAVE :: ecrit_tra_omp
+    REAL,SAVE :: cvl_comp_threshold_omp
+    REAL,SAVE :: cvl_sig2feed_omp
     REAL,SAVE :: cvl_corr_omp
     LOGICAL,SAVE :: ok_lic_melt_omp
@@ -213,4 +220,5 @@
     !-----------------------------------------------------------------
 
+     print*,'CONFPHYS ENTREE'
     !$OMP MASTER 
     !Config Key  = type_ocean 
@@ -760,4 +768,20 @@
     ! KE
     !
+
+    !Config key  = cvl_comp_threshold
+    !Config Desc = maximum fraction of convective points enabling compression
+    !Config Def  = 1.00
+    !Config Help = fields are compressed when less than a fraction cvl_comp_threshold
+    !Config Help = of the points is convective.
+    cvl_comp_threshold_omp = 1.00
+    CALL getin('cvl_comp_threshold', cvl_comp_threshold_omp)
+
+    !Config key  = cvl_sig2feed
+    !Config Desc = sigma coordinate at top of feeding layer
+    !Config Def  = 0.97
+    !Config Help = deep convection is fed by the layer extending from the surface (pressure ps)
+    !Config Help = and cvl_sig2feed*ps.
+    cvl_sig2feed_omp = 0.97
+    CALL getin('cvl_sig2feed', cvl_sig2feed_omp)
 
     !Config key  = cvl_corr
@@ -1645,31 +1669,46 @@
     !
     !
+    print*,'CONFPHYS OOK avant drag_ter'
     !
     ! PARAMETRES CDRAG
-    !
-    !Config Key  = f_cdrag_ter
-    !Config Desc =
-    !Config Def  = 0.8
-    !Config Help =
     !
     f_cdrag_ter_omp = 0.8
     call getin('f_cdrag_ter',f_cdrag_ter_omp)
     !
-    !Config Key  = f_cdrag_oce
-    !Config Desc =
-    !Config Def  = 0.8
-    !Config Help =
-    !
     f_cdrag_oce_omp = 0.8
     call getin('f_cdrag_oce',f_cdrag_oce_omp)
     !
-    ! RUGORO
-    !Config Key  = f_rugoro
-    !Config Desc =
-    !Config Def  = 0.
-    !Config Help =
-    !
+
+! Gustiness flags
+    f_z0qh_oce_omp = 1.
+    call getin('f_z0qh_oce',f_z0qh_oce_omp)
+    !
+    f_qsat_oce_omp = 1.
+    call getin('f_qsat_oce',f_qsat_oce_omp)
+    !
+    f_gust_bl_omp = 0.
+    call getin('f_gust_bl',f_gust_bl_omp)
+    !
+    f_gust_wk_omp = 0.
+    call getin('f_gust_wk',f_gust_wk_omp)
+    !
+    iflag_z0_oce_omp=0
+    call getin('iflag_z0_oce',iflag_z0_oce_omp)
+    !
+    iflag_gusts_omp=0
+    call getin('iflag_gusts',iflag_gusts_omp)
+    !
+    min_wind_speed_omp = 1.
+    call getin('min_wind_speed',min_wind_speed_omp)
+
+    z0m_seaice_omp = 0.002 ; call getin('z0m_seaice',z0m_seaice_omp)
+    z0h_seaice_omp = 0.002 ; call getin('z0h_seaice',z0h_seaice_omp)
+
     f_rugoro_omp = 0.
     call getin('f_rugoro',f_rugoro_omp)
+
+    z0min_omp = 0.000015
+    call getin('z0min',z0min_omp)
+
 
     ! PARAMETERS FOR CONVECTIVE INHIBITION BY TROPOS. DRYNESS
@@ -1751,4 +1790,13 @@
     Fmax_omp = 0.65
     call getin('Fmax',Fmax_omp)
+
+    !
+    !Config Key  = tmax_fonte_cv
+    !Config Desc =
+    !Config Def  = 275.15
+    !Config Help =
+    !
+    tmax_fonte_cv_omp = 275.15
+    call getin('tmax_fonte_cv',tmax_fonte_cv_omp)
 
     !
@@ -2018,9 +2066,26 @@
     ecrit_tra = ecrit_tra_omp
     ecrit_reg = ecrit_reg_omp
+    cvl_comp_threshold = cvl_comp_threshold_omp
+    cvl_sig2feed = cvl_sig2feed_omp
     cvl_corr = cvl_corr_omp
     ok_lic_melt = ok_lic_melt_omp
     f_cdrag_ter=f_cdrag_ter_omp
     f_cdrag_oce=f_cdrag_oce_omp
+
+    f_gust_wk=f_gust_wk_omp
+    f_gust_bl=f_gust_bl_omp
+    f_qsat_oce=f_qsat_oce_omp
+    f_z0qh_oce=f_z0qh_oce_omp
+    min_wind_speed=min_wind_speed_omp
+    iflag_gusts=iflag_gusts_omp
+    iflag_z0_oce=iflag_z0_oce_omp
+
+
+    z0m_seaice=z0m_seaice_omp
+    z0h_seaice=z0h_seaice_omp
+
     f_rugoro=f_rugoro_omp
+
+    z0min=z0min_omp
     supcrit1 = supcrit1_omp
     supcrit2 = supcrit2_omp
@@ -2031,4 +2096,5 @@
     gammas = gammas_omp
     Fmax = Fmax_omp
+    tmax_fonte_cv = tmax_fonte_cv_omp
     alphas = alphas_omp
     ok_strato = ok_strato_omp
@@ -2105,4 +2171,6 @@
     write(lunout,*)' RN2O_per = ',RN2O_per,' RCFC11_per = ', RCFC11_per
     write(lunout,*)' RCFC12_per = ',RCFC12_per
+    write(lunout,*)' cvl_comp_threshold=', cvl_comp_threshold
+    write(lunout,*)' cvl_sig2feed=', cvl_sig2feed
     write(lunout,*)' cvl_corr=', cvl_corr
     write(lunout,*)'ok_lic_melt=', ok_lic_melt
@@ -2210,4 +2278,5 @@
     write(lunout,*)' f_cdrag_oce = ',f_cdrag_oce
     write(lunout,*)' f_rugoro = ',f_rugoro
+    write(lunout,*)' z0min = ',z0min
     write(lunout,*)' supcrit1 = ', supcrit1
     write(lunout,*)' supcrit2 = ', supcrit2
@@ -2218,4 +2287,5 @@
     write(lunout,*)' gammas = ', gammas
     write(lunout,*)' Fmax = ', Fmax
+    write(lunout,*)' tmax_fonte_cv = ', tmax_fonte_cv
     write(lunout,*)' alphas = ', alphas
     write(lunout,*)' iflag_wake = ', iflag_wake
